
/* \file
 * temporal pitch detection function 
 *
 * designed from "An Autocorrelation Pitch Detector and Voicing
 * Decision with Confidence Measures Developed for Noise-Corrupted
 * Speech", David A. Krusback and Russel J. Niederjohn, in IEEE
 * Transactions on Signal Processing */

#ifndef PITCHAUTOTCORR_H
#define PITCHAUTOTCORR_H

#ifdef __cplusplus
extern "C" {
#endif


/** main autocorr function. this should be done on input after
 * preprocessing (butterworth lowpass 0-600Hz) 
 *
 * we avoid calculating these values for l = [1 ... 29]
 * 
 */
void aubio_pitch_autocorr(fvec_t * input, fvec_t * window, fvec_t * autocorr);

/** peak the autocorr vector and returns the most likely bin */
uint_t aubio_pitch_getautocorr(fvec_t * s);

#ifdef __cplusplus
}
#endif

#endif /*PITCHDETECTION_H*/ 
